/*
 * A quick sort algorithm
 * 
 *
 * This is a generic version of C.A.R Hoare's Quick Sort 
 * algorithm.  This will handle arrays that are already
 * sorted, and arrays with duplicate keys.
 *
 * If you think of a one dimensional array as going from
 * the lowest index on the left to the highest index on the right
 * then the parameters to this function are lowest index or
 * left and highest index or right.  The first time you call
 * this function it will be with the parameters 0, a.length - 1.
 *
 * a       an integer array
 * lo0     left boundary of array partition
 * hi0     right boundary of array partition
 */
 
int a[10];

quickSort( lo0, hi0) 
  int lo0, hi0;
{
  int lo, hi, mid;

  lo = lo0;
  hi = hi0;

  if ( hi0 > lo0)
  {

     /* Arbitrarily establishing partition element as the midpoint of
      * the array.
      */
     mid = a[ ( lo0 + hi0 ) / 2 ];

     /* loop through the array until indices cross */
     while( lo <= hi ) {
       /* find the first element that is greater than or equal to 
        * the partition element starting from the left Index.
        */
       while( ( lo < hi0 ) &&( a[lo] < mid ))
         ++lo;

       /* find an element that is smaller than or equal to 
        * the partition element starting from the right Index.
        */
       while( ( hi > lo0 ) && ( a[hi] > mid ))
         --hi;

       /* if the indexes have not crossed, swap */
       if( lo <= hi ) {
         swap(lo, hi);
         ++lo;
         --hi;
       }
     } /* while( lo <= hi )*/

     /* If the right index has not reached the left side of array
      * must now sort the left partition.
      */
     if( lo0 < hi )
       quickSort( lo0, hi );

     /* If the left index has not reached the right side of array
      * must now sort the right partition.
      */
     if( lo < hi0 )
       quickSort( lo, hi0 );
  } /* if ( hi0 > lo0) */
} /* quickSort*/

swap(i, j)
  int i, j;
{
  int T;
  T = a[i]; 
  a[i] = a[j];
  a[j] = T;
}

main() {
  int i;

  i = 10;
  while (i > 0){
    a[10 - i] = i;
    --i;
  }

  quickSort(0, 9);

}
